Last Comment Bug 680903 - Sort out classinfo for modal content windows and chrome windows
: Sort out classinfo for modal content windows and chrome windows
Status: RESOLVED FIXED
:
Product: Core
Classification: Components
Component: DOM (show other bugs)
: Trunk
: All All
: P1 normal (vote)
: mozilla9
Assigned To: Boris Zbarsky [:bz] (still a bit busy)
:
:
Mentors:
Depends on: 659350
Blocks:
  Show dependency treegraph
 
Reported: 2011-08-22 07:57 PDT by Boris Zbarsky [:bz] (still a bit busy)
Modified: 2011-09-26 07:45 PDT (History)
7 users (show)
bzbarsky: in‑testsuite?
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
Make the set of interfaces exposed by windows saner across different window types. (5.29 KB, patch)
2011-08-24 13:07 PDT, Boris Zbarsky [:bz] (still a bit busy)
jst: review+
Details | Diff | Splinter Review

Description Boris Zbarsky [:bz] (still a bit busy) 2011-08-22 07:57:17 PDT
See bug 659350 comment 31.  Modal content windows and chrome windows are missing some interfaces that normal content windows have.

Jonas, Ben: should chrome windows support indexeddb in classinfo?
Comment 1 Boris Zbarsky [:bz] (still a bit busy) 2011-08-22 08:01:18 PDT
Er, looks like in fact chrome and modal content windows _do_ support indexeddb.  Unconditionally, unlike content windows.

Doug, you made that change in bug 623316.  Why is the support for modal content windows unconditional?
Comment 2 Ben Turner (not reading bugmail, use the needinfo flag!) 2011-08-22 10:02:13 PDT
indexedDB should be available everywhere (except in third party windows, but we block that in other ways).
Comment 3 Boris Zbarsky [:bz] (still a bit busy) 2011-08-22 12:22:29 PDT
OK, and should it be unconditionally available in modal content windows?  Or conditionally?
Comment 4 Ben Turner (not reading bugmail, use the needinfo flag!) 2011-08-22 12:46:36 PDT
I don't see any reason why modal content windows should be any different from regular content windows... Is there something that sets them apart that I'm missing?
Comment 5 Ben Turner (not reading bugmail, use the needinfo flag!) 2011-08-22 12:47:16 PDT
Making sure sicking agrees... sicking?
Comment 6 Boris Zbarsky [:bz] (still a bit busy) 2011-08-22 13:06:18 PDT
That was my feeling, but it didn't match our existing code, so I just wanted to make sure I wasn't missing anything.
Comment 7 Jonas Sicking (:sicking) No longer reading bugmail consistently 2011-08-22 13:25:00 PDT
I'm also not sure why modal makes a difference.

I could however see that being able to open a new "toplevel" window from deeply within a frame hierarchy could be used as a way to circumvent the 3rd party checks that we have.

We've been kind'a relying on the popup blocker and the fact that sites don't want to open popups in order to have them not work around our 3rd party block. Is the concern that modal windows somehow changes this?
Comment 8 Boris Zbarsky [:bz] (still a bit busy) 2011-08-22 13:41:16 PDT
To be clear, right now modal content windows unconditionally allow indexeddb.  I was assuming that's for some reason, but it starting to sound like it was just a bug...
Comment 9 Boris Zbarsky [:bz] (still a bit busy) 2011-08-24 13:07:14 PDT
Created attachment 555505 [details] [diff] [review]
Make the set of interfaces exposed by windows saner across different window types.
Comment 10 Jonas Sicking (:sicking) No longer reading bugmail consistently 2011-09-19 15:00:13 PDT
Comment on attachment 555505 [details] [diff] [review]
Make the set of interfaces exposed by windows saner across different window types.

I think jst, peterv or mrbkap would make better reviewers here
Comment 11 Boris Zbarsky [:bz] (still a bit busy) 2011-09-22 22:06:14 PDT
https://hg.mozilla.org/integration/mozilla-inbound/rev/b55b2c3a2fdb
Comment 12 Ed Morley [:emorley] 2011-09-23 04:35:45 PDT
https://hg.mozilla.org/mozilla-central/rev/b55b2c3a2fdb
Comment 13 :Ms2ger (⌚ UTC+1/+2) 2011-09-24 04:07:10 PDT
Comment on attachment 555505 [details] [diff] [review]
Make the set of interfaces exposed by windows saner across different window types.

>--- a/dom/base/nsDOMClassInfo.cpp
>+++ b/dom/base/nsDOMClassInfo.cpp
>   // FIXME: Bug 680903.  Should ModalContentWindow really not have
>   // touch, performance apis and have unconditional indexeddb??

Fixed?
Comment 14 Boris Zbarsky [:bz] (still a bit busy) 2011-09-25 21:55:35 PDT
Er, yes.  Pushed a followup as http://hg.mozilla.org/integration/mozilla-inbound/rev/7ccfcddfed82

Note You need to log in before you can comment on or make changes to this bug.